package llc.arma.ble.app.ui.screen.inspection.accelerometer.view

import androidx.compose.foundation.clickable
import androidx.compose.foundation.layout.Box
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.Row
import androidx.compose.foundation.layout.Spacer
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.fillMaxWidth
import androidx.compose.foundation.layout.height
import androidx.compose.foundation.layout.padding
import androidx.compose.foundation.shape.CircleShape
import androidx.compose.foundation.shape.RoundedCornerShape
import androidx.compose.material3.MaterialTheme
import androidx.compose.material3.RadioButton
import androidx.compose.material3.Surface
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.draw.clip
import androidx.compose.ui.unit.dp
import llc.arma.ble.app.ui.screen.inspection.accelerometer.AccelerometerContract
import llc.arma.ble.domain.model.Ble
import llc.arma.ble.domain.usecase.AccelScale

@Composable
fun AccelScaleEdit(
    next: AccelerometerContract.Event.Next,
    state: AccelerometerContract.State.Display,
    onEvent: (AccelerometerContract.Event) -> Unit,
){

    var fftMode = when(next){
        AccelerometerContract.Event.Next.ACCEL ->
            state.accelScale
        AccelerometerContract.Event.Next.HISTORY -> {
            val history = state.accelerometer.accelerometerState.saveHistory
            if (history is Ble.Accelerometer.HistorySettings.Enabled)
                history.scale
            else {
                state.accelScale
            }
        }
    }

    Column(
        modifier = Modifier
    ) {

        Text(
            modifier = Modifier.padding(horizontal = 12.dp),
            text = "Accel scale",
            style = MaterialTheme.typography.titleLarge
        )

        Spacer(modifier = Modifier.height(16.dp))

        AccelScale.values().forEach {

            Row(
                verticalAlignment = Alignment.CenterVertically,
                modifier = Modifier
                    .fillMaxWidth()
                    .clip(RoundedCornerShape(8.dp))
                    .clickable {
                        when(next){
                            AccelerometerContract.Event.Next.ACCEL ->
                                onEvent(AccelerometerContract.Event.OnAccelScaleChanged(it))
                            AccelerometerContract.Event.Next.HISTORY ->
                                onEvent(AccelerometerContract.Event.OnHistoryScaleChanged(it))
                        }
                    }
                    .padding(4.dp)
            ) {

                RadioButton(
                    selected = it == fftMode,
                    onClick = {
                        when(next){
                            AccelerometerContract.Event.Next.ACCEL ->
                                onEvent(AccelerometerContract.Event.OnAccelScaleChanged(it))
                            AccelerometerContract.Event.Next.HISTORY ->
                                onEvent(AccelerometerContract.Event.OnHistoryScaleChanged(it))
                        }

                    }
                )

                Text(text = it.localized)

            }

        }

        Spacer(modifier = Modifier.height(16.dp))

        Surface(
            modifier = Modifier
                .fillMaxWidth()
                .padding(8.dp)
                .height(50.dp),
            shape = CircleShape,
            color = MaterialTheme.colorScheme.primaryContainer,
            onClick = {
                when(next){
                    AccelerometerContract.Event.Next.ACCEL ->
                        onEvent(AccelerometerContract.Event.OnAccelEdit)
                    AccelerometerContract.Event.Next.HISTORY ->
                        onEvent(AccelerometerContract.Event.OnHistoryEdit)
                }

            }
        ) {

            Box(modifier = Modifier.fillMaxSize()) {

                Text(
                    modifier = Modifier.align(Alignment.Center),
                    color = MaterialTheme.colorScheme.background,
                    style = MaterialTheme.typography.labelLarge,
                    text = "Ок"
                )

            }

        }

    }

}